import os
import platform


def build_dir(workspace):
    return os.path.join(workspace, "build")


def charm_repo_dir(workspace):
    return os.path.join(workspace, "charms")


def charm_repo_series_dir(workspace, series="precise"):
    return os.path.join(workspace, "charms", series)


def config_dir(workspace):
    return os.path.join(workspace, "configuration")


def local_dir(workspace):
    return os.path.join(workspace, "local")


def log_dir(workspace):
    return os.path.join(workspace, "log")


def build_tag():
    return "{}-{}".format(platform.node(), os.getpid())


def get_workspace(workspace):
    if not workspace:
        workspace = os.curdir
        print "No workspace specified, using {}".format(workspace)
    return os.path.abspath(workspace)


class ConfigNotFoundException(Exception):
    pass


def get_config_file(workspace, base, envtag=None):
    config_base = os.path.join(config_dir(workspace), base, base)
    config_names = [config_base]
    if envtag:
        config_names.insert(0, "{}-{}".format(config_base, envtag))
    for config in config_names:
        if os.path.exists(config):
            return config
    raise ConfigNotFoundException("Config not found: " + ", ".join(config_names))
